<?php

  class mw_data_users extends mw_data{

    var $users;
    var $_user;
    var $user_status;
    var $action_status;

    # ----------------------------------------------------------------------------------------
    #                                                                                    users
    #

    function users($start = 0, $alpha = null, $status = null){
      $sgbd = $this->sgbd();
      $env = $this->env();
      $users = array("list" => array(), "total" => 0);
      $res = array();
      if($rst = $sgbd->open_data("users")){
        while($v_rst = $sgbd->fetch_data($rst)){
          if(isset($v_rst)){
            if(!isset($alpha) || (isset($v_rst["login"]) && strtolower(substr($v_rst["login"], 0, 1)) == strtolower($alpha))){
              if(!isset($status) || (isset($v_rst["status"]) && $v_rst["status"] == $status)){
                $res[$v_rst["id"]] = $v_rst;
                $users["total"]++;
              }
            }
          }
          else{
            $res = false;
            break;
          }
        }
        $sgbd->close_data($rst);
        if($res !== false){
          $n = 0;
          foreach($res as $id_user => $user){
            $n++;
            if(!$env->config("max_list") || ($n > $start && $n <= ($start + $env->config("max_list")))){
              $users["list"][$user["id"]] = $user;
              if(!isset($this->users)) $this->users = array();
              $this->users[$user["id"]] = $user;
            }
          }
          foreach($users["list"] as $id_user => $user){
            if(($status = $this->list_user_status($id_user)) !== false){
              $users["list"][$id_user]["status"] = $status;
            }
            else{
              $users = false;
              break;
            }
          }
        }
        else $users = false;
      }
      else $users = false;
      return $users;
    }

    function list_user_status($id_user){
      $sgbd = $this->sgbd();
      $status = array();
      if($rst = $sgbd->open_data("users_roles")){
        while($v_rst = $sgbd->fetch_data($rst)){
          if(isset($v_rst)){
            if(isset($v_rst["id_role"]) && isset($v_rst["id_user"]) && $v_rst["id_user"] == $id_user){
              $status[] = $v_rst["id_role"];
            }
          }
          else{
            $status = false;
            break;
          }
        }
        $sgbd->close_data($rst);
      }
      else $status = false;
      return $status;
    }

    function user_by_id($id){
      if(!isset($this->users)) $this->users = array();
      if(isset($this->users[$id])) return $this->users[$id];
      $sgbd = $this->sgbd();
      if(($user = $sgbd->get_data("users", $id)) !== false){
        $this->users[$id] = $user;
        if(($status = $this->list_user_status($user["id"])) !== false) $user["status"] = $status;
        else $user = false;
      }
      return $user;
    }

    function user($login){
      $sgbd = $this->sgbd();
      $user = array();
      if($rst = $sgbd->open_data("users")){
        while($v_rst = $sgbd->fetch_data($rst)){
          if(isset($v_rst)){
            if(isset($v_rst["login"]) && $v_rst["login"] == $login){
              $user = $v_rst;
              break;
            }
          }
          else $user = false;
        }
        $sgbd->close_data($rst);
        if($user){
          if(($status = $this->list_user_status($user["id"])) !== false) $user["status"] = $status;
          else $user = false;
        }
      }
      else $user = false;
      if($user !== false){
        if(!isset($this->users)) $this->users = array();
        if($user) $this->users[$user["id"]] = $user;
      }
      return $user;
    }

    function user_exists($login){
      $sgbd = $this->sgbd();
      $EXISTS = 0;
      if($rst = $sgbd->open_data("users")){
        while($v_rst = $sgbd->fetch_data($rst)){
          if(isset($v_rst)){
            if(isset($v_rst["login"]) && $v_rst["login"] == $login){
              $EXISTS++;
            }
          }
          else{
            $EXISTS = false;
            break;
          }
        }
        $sgbd->close_data($rst);
      }
      else $EXISTS = false;
      return $EXISTS;
    }

    function add_user($login, $password, $email, $status){
      $sgbd = $this->sgbd();
      if(
        (
          $id_user = $sgbd->add_data(
            "users",
            array(
              "login" => $login,
              "password" => $password,
              "email" => $email
            )
          )
        ) === false
      ) return false;
      $OK = true;
      foreach($status as $id_role){
        $OK = $sgbd->add_data(
          "users_roles",
          array(
            "id_user" => $id_user,
            "id_role" => $id_role
          )
        );
        if(!$OK) break;
      }
      if(!$OK) return false;
      return $id_user;
    }

    function set_user($id, $login, $password, $email, $status){
      $sgbd = $this->sgbd();
      if(
        !$sgbd->set_data(
          "users",
          $id,
          array(
            "login" => $login,
            "password" => $password,
            "email" => $email
          )
        )
      ) return false;
      if($rst = $sgbd->open_data("users_roles")){
        $OK = true;
        while($v_rst = $sgbd->fetch_data($rst)){
          if(isset($v_rst)){
            if(isset($v_rst["id"]) && isset($v_rst["id_user"]) && $v_rst["id_user"] == $id){
              if(!$sgbd->del_data("users_roles", $v_rst["id"])){
                $OK = false;
                break;
              }
            }
          }
          else $OK = false;
        }
        $sgbd->close_data($rst);
        if(!$OK) return false;
      }
      else return false;
      foreach($status as $id_role){
        $OK = $sgbd->add_data(
          "users_roles",
          array(
            "id_user" => $id,
            "id_role" => $id_role
          )
        );
        if(!$OK) break;
      }
      if(!$OK) return false;
      return true;
    }

    function del_user($login){
      if(($user = $this->user($login)) !== false){
        $sgbd = $this->sgbd();
        if(!$sgbd->del_data("users", $user["id"])) return false;
        if($rst = $sgbd->open_data("users_roles")){
          $OK = true;
          while($v_rst = $sgbd->fetch_data($rst)){
            if(isset($v_rst)){
              if(isset($v_rst["id"]) && isset($v_rst["id_user"]) && $v_rst["id_user"] == $user["id"]){
                if(!$sgbd->del_data("users_roles", $v_rst["id"])){
                  $OK = false;
                  break;
                }
              }
            }
            else $OK = false;
          }
          $sgbd->close_data($rst);
          return $OK;
        }
      }
      return false;
    }

    # ----------------------------------------------------------------------------------------
    #                                                                                   status
    #

    function init_user_status($status = array()){
      $sgbd = $this->sgbd();
      $this->user_status = array();
      if($rst = $sgbd->open_data("roles")){
        while($v_rst = $sgbd->fetch_data($rst)){
          if(isset($v_rst)){
            $this->user_status[$v_rst["id"]] = $v_rst;
          }
          else{
            $this->user_status = false;
            break;
          }
        }
        $sgbd->close_data($rst);
      }
      else $this->user_status = false;
      return $this->user_status;
    }

    function add_role($nom, $intitule){
      $sgbd = $this->sgbd();
      $id_role = $sgbd->add_data(
        "roles",
        array(
          "nom" => $nom,
          "intitule" => $intitule
        )
      );
      if(!isset($id_role)) return false;
      return $id_role;
    }

    function get_role($id){
      if($id === "0") return array(
        "id" => 0,
        "nom" => "",
        "intitule" => ""
      );
      $sgbd = $this->sgbd();
      $role = $sgbd->get_data("roles", $id);
      if(!isset($role)) return false;
      return $role ? $role : array();
    }

    function set_role($id, $nom, $intitule){
      $sgbd = $this->sgbd();
      if(
        !$sgbd->set_data(
          "roles",
          $id,
          array(
            "nom" => $nom,
            "intitule" => $intitule
          )
        )
      ) return false;
      return true;
    }

    function clear_role_actions($id_role){
      $sgbd = $this->sgbd();
      if($rst = $sgbd->open_data("action_status")){
        $OK = true;
        while($v_rst = $sgbd->fetch_data($rst)){
          if(isset($v_rst)){
            if(isset($v_rst["id"]) && isset($v_rst["id_status"]) && $v_rst["id_status"] == $id_role){
              if(!$sgbd->del_data("action_status", $v_rst["id"])){
                $OK = false;
                break;
              }
            }
          }
          else $OK = false;
        }
        $sgbd->close_data($rst);
        return $OK;
      }
      return false;
    }

    function clear_role_users($id_role){
      $sgbd = $this->sgbd();
      if($rst = $sgbd->open_data("users_roles")){
        $OK = true;
        while($v_rst = $sgbd->fetch_data($rst)){
          if(isset($v_rst)){
            if(isset($v_rst["id"]) && isset($v_rst["id_role"]) && $v_rst["id_role"] == $id_role){
              if(!$sgbd->del_data("users_roles", $v_rst["id"])){
                $OK = false;
                break;
              }
            }
          }
          else $OK = false;
        }
        $sgbd->close_data($rst);
        return $OK;
      }
      return false;
    }

    function add_role_action($id_role, $action){
      $sgbd = $this->sgbd();
      $id_action_status = $sgbd->add_data(
        "action_status",
        array(
          "action" => $action,
          "id_status" => $id_role
        )
      );
      if(!isset($id_action_status)) return false;
      return $id_action_status;
    }

    function del_role($id_role){
      $sgbd = $this->sgbd();
      return $sgbd->del_data("roles", $id_role) ? true : false;
    }

    function status(){
      if(!isset($this->user_status)) return false;
      return $this->user_status;
    }

    function get_user_status(){
      $user_status = array();
      $user = $this->get_session_user();
      if($user && isset($user["id"])){
        $sgbd = $this->sgbd();
        if($rst = $sgbd->open_data("users_roles")){
          while($v_rst = $sgbd->fetch_data($rst)){
            if(isset($v_rst)){
              if(isset($v_rst["id_role"]) && isset($v_rst["id_user"]) && $v_rst["id_user"] == $user["id"]){
                $user_status[] = $v_rst["id_role"];
              }
            }
            else{
              $user_status = false;
              break;
            }
          }
          $sgbd->close_data($rst);
        }
        else $user_status = false;
        if($user_status === false) return false;
      }
      else $user_status[] = 0;
      if(!$user_status) $user_status[] = 0;
      return $user_status;
    }

    function init_action_status($status = array()){
      if(!isset($this->user_status)) return false;
      $this->action_status = $this->read_action_status();
      return $this->action_status;
    }

    function read_action_status($params = array()){
      if(!isset($this->user_status)) return false;
      $group_by_action = isset($params["group_by_action"]) ? $params["group_by_action"] : false;
      $sgbd = $this->sgbd();
      $action_status = array();
      if($rst = $sgbd->open_data("action_status")){
        while($v_rst = $sgbd->fetch_data($rst)){
          if(isset($v_rst)){
            if(isset($v_rst["action"]) && isset($v_rst["id_status"])){
              if($group_by_action){
                if(!isset($action_status[$v_rst["action"]])) $action_status[$v_rst["action"]] = array();
                $action_status[$v_rst["action"]][] = $v_rst["id_status"];
              }
              else $action_status[$v_rst["id"]] = $v_rst;
            }
          }
          else{
            $action_status = false;
            break;
          }
        }
        $sgbd->close_data($rst);
      }
      else $action_status = false;
      return $action_status;
    }

    function get_action_status($mod, $controller = "index", $action = "index", $set_status = array()){
      $sgbd = $this->sgbd();
      $status = array();
      if($rst = $sgbd->open_data("action_status")){
        while($status !==false && $v_rst = $sgbd->fetch_data($rst)){
          if(isset($v_rst) && isset($v_rst["action"]) && isset($v_rst["id_status"])){
            if(
                 $v_rst["action"] == $mod
              || $v_rst["action"] == $mod."/".$controller
              || $v_rst["action"] == $mod."/".$controller."/".$action
            ){
              if(!isset($status[$v_rst["action"]])) $status[$v_rst["action"]] = array();
              $status[$v_rst["action"]][$v_rst["id_status"]] = true;
            }
          }
          else $status = false;
        }
        $sgbd->close_data($rst);
      }
      else $status = false;
      return $status;
    }

    function get_actions($id_role = null){
      $env = $this->env();
      if($actions = $env->get_actions()){
        if(($action_status = $this->read_action_status(array("group_by_action" => true))) !== false){
          foreach($actions as $module_name => $module){
            if(isset($id_role)) $actions[$module_name]["module_allowed"] =
                isset($action_status[$module_name])
            &&  in_array($id_role, $action_status[$module_name]);
            $actions[$module_name]["is_public"] =
                isset($action_status[$module_name])
            &&  in_array(0, $action_status[$module_name]);
            foreach($module["controleurs"] as $controleur_name => $controleur){
              if(isset($id_role)) $actions[$module_name]["controleurs"][$controleur_name]["controleur_allowed"] =
                  isset($action_status[$module_name."/".$controleur_name])
              &&  in_array($id_role, $action_status[$module_name."/".$controleur_name]);
              $actions[$module_name]["controleurs"][$controleur_name]["is_public"] =
                  isset($action_status[$module_name."/".$controleur_name])
              &&  in_array(0, $action_status[$module_name."/".$controleur_name]);
              foreach($controleur["als"] as $index_als => $al){
                if($al["actions"]){
                  if(isset($id_role)){
                    $HAS_ACTION_NOT_ALLOWED = false;
                    foreach($al["actions"] as $action_name){
                      if(
                          !isset($action_status[$module_name."/".$controleur_name."/".$action_name])
                      ||  !in_array($id_role, $action_status[$module_name."/".$controleur_name."/".$action_name])
                      ){
                        $HAS_ACTION_NOT_ALLOWED = true;
                        break;
                      }
                    }
                    if(!$HAS_ACTION_NOT_ALLOWED){
                      $actions[$module_name]["controleurs"][$controleur_name]["als"][$index_als]["action_allowed"] = true;
                    }
                  }
                  $HAS_ACTION_NOT_ALLOWED = false;
                  foreach($al["actions"] as $action_name){
                    if(
                        !isset($action_status[$module_name."/".$controleur_name."/".$action_name])
                    ||  !in_array(0, $action_status[$module_name."/".$controleur_name."/".$action_name])
                    ){
                      $HAS_ACTION_NOT_ALLOWED = true;
                      break;
                    }
                  }
                  if(!$HAS_ACTION_NOT_ALLOWED){
                    $actions[$module_name]["controleurs"][$controleur_name]["als"][$index_als]["is_public"] = true;
                  }
                }
              }
            }
          }
          return $actions;
        }
      }
      return array();
    }

    # ----------------------------------------------------------------------------------------
    #                                                                             log in / out
    #

    function login($login, $password){
      if(($user = $this->user($login)) !== false){
        if($this->password_ok($user, $password)){
          if(!$this->set_session($user)) $user = false;
        }
        else{
          $this->clear_session();
          $user = array();
        }
      }
      return $user;
    }

    function logout(){
      return $this->clear_session();
    }

    function user_ok($user){
      return
      strcmp(md5($user["password"].$_SESSION["id"]), $_SESSION["pass"]) == 0
      && $_SESSION["ip"] == $_SERVER["REMOTE_ADDR"];
    }

    function password_ok($user, $password){
      if(!$user) return false;
      return
           strcmp(md5($user["password"].$_SESSION["id"]), $password) == 0
        && $_SESSION["ip"] == $_SERVER["REMOTE_ADDR"];
    }

    # ----------------------------------------------------------------------------------------
    #                                                                                  session
    #

    function load_session(){
      session_start();
      if(!isset($_SESSION["id"])) $this->clear_session();
      if(
        $user = (
          isset($_COOKIE["user"]) || isset($_SESSION["user"]) ?
            $this->user(isset($_COOKIE["user"]) ? $_COOKIE["user"] : $_SESSION["user"])
          : array()
        )
      ){
        if(isset($_COOKIE["user"])) $this->set_session($user);
        if(!$this->user_ok($user)){
          $this->clear_session();
          $user = array();
        }
      }
      $this->_user = $user;
      return $user;
    }

    function set_session($user){
      $_SESSION["user"] = $user["login"];
      $_SESSION["pass"] = md5($user["password"].$_SESSION["id"]);
      $env = $this->env();
      return setcookie("user", $user["login"], time() + (60 * 60 * 24 * 7), $env->path("web"));
    }

    function clear_session(){
      unset($_SESSION["user"]);
      unset($_SESSION["pass"]);
      $_SESSION["ip"] = $_SERVER["REMOTE_ADDR"];
      $_SESSION["id"] = md5(rand());
      $env = $this->env();
      return setcookie("user", "", 0, $env->path("web"));
    }

    function get_session_user(){
      return $this->_user;
    }

    # ----------------------------------------------------------------------------------------
    #                                                                                  uploads
    #

    function check_user_uploads_dir($user = null){
      $env = $this->env();
      $user_dir = $env->path("content")."uploads/".(isset($user) ? $user : $this->_user["id"]);
      if(!file_exists($user_dir)) @mkdir($user_dir);
      return file_exists($user_dir);
    }

  }

?>